using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace KeyManager
{
    public partial class Form1 : Form
    {
        private WeOnlyDo.Security.Cryptography.KeyManager KeyM = new WeOnlyDo.Security.Cryptography.KeyManager();
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            LoadKey();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            comboBox1.SelectedIndex = 0;
            openFileDialog1.FileOk += new CancelEventHandler(openFileDialog1_FileOk);
            savePrivatekey.FileOk += new CancelEventHandler(saveFileDialog1_FileOk);
            savePublicKey.FileOk += new CancelEventHandler(saveFileDialog2_FileOk);
        }

        void saveFileDialog2_FileOk(object sender, CancelEventArgs e)
        {
            if (e.Cancel != true)
            {
                try
                {
                    if (KeyM.PublicKeyOpenSSH(GetKeyType(comboBox1.SelectedIndex)) != "")
                    {
                        System.IO.File.WriteAllText(savePublicKey.FileName, txtPublicOSSH.Text);
                    }
                }
                catch(Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }

        void saveFileDialog1_FileOk(object sender, CancelEventArgs e)
        {
            if (e.Cancel != true)
            {
                try
                {
                    KeyM.Save(savePrivatekey.FileName, txtPass.Text);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }

        void openFileDialog1_FileOk(object sender, CancelEventArgs e)
        {
            if (e.Cancel != true)
            {
                String PubKey = null;
                try
                {
                    KeyM.Load(openFileDialog1.FileName, txtPass.Text);
                    txtHash.Clear();
                    try
                    {
                        txtPublicOSSH.Text = KeyM.PublicKeyOpenSSH(WeOnlyDo.Security.Cryptography.SSHKeyTypes.RSAKey);
                        comboBox1.SelectedIndex = 0;
                        PubKey = KeyM.PublicKeyOpenSSH(WeOnlyDo.Security.Cryptography.SSHKeyTypes.RSAKey);
                    }
                    catch (Exception KeyTypeEx)
                    {
                        if (KeyTypeEx.Message != "")
                        {
                            txtPublicOSSH.Text = KeyM.PublicKeyOpenSSH(WeOnlyDo.Security.Cryptography.SSHKeyTypes.DSAKey);
                            comboBox1.SelectedIndex = 1;
                            PubKey = KeyM.PublicKeyOpenSSH(WeOnlyDo.Security.Cryptography.SSHKeyTypes.DSAKey);
                        }
                    }
                    Hash(PubKey);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }

            }
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Cursor = Cursors.AppStarting;
            GenerateKey();
            Cursor = Cursors.Default;
        }

        private void Hash(String PubKey)
        {
            // ignore 'ssh-rsa' or 'ssh-dsa' word
            PubKey = PubKey.Substring(7);
            // and conver to byte array from base64
            Byte[] ByteKey = System.Convert.FromBase64String(PubKey);
            Byte[] HashedValue;
                
                System.Security.Cryptography.MD5CryptoServiceProvider md5 = new System.Security.Cryptography.MD5CryptoServiceProvider ();
                HashedValue = md5.ComputeHash(ByteKey);
                int i;
                for (i = 0; i <= HashedValue.Length - 1; i++)
                {
                    if (i != 0) 
                    {
                        txtHash.Text += ":";
                    }
                    String a;
                    a = Convert.ToString(HashedValue[i], 16);
                    a = a.ToUpper();
                    if (a.Length < 2)
                    {
                        a = a.Insert(0, "0");
                        txtHash.Text += a;
                    }
                    else
                    {
                        txtHash.Text += a;
                    }              
                }
        }

        private void GenerateKey()
        {
            txtPublicOSSH.Clear();
            txtHash.Clear();
            KeyM.Generate(GetKeyType(comboBox1.SelectedIndex), Convert.ToInt16(txtBitCount.Text));
            txtPublicOSSH.Text = KeyM.PublicKeyOpenSSH(GetKeyType(comboBox1.SelectedIndex));
            Hash(KeyM.PublicKeyOpenSSH(GetKeyType(comboBox1.SelectedIndex)));
        }

        private void ShowXMLForm()
        {
            try
            {
                XMLStringForm xmlStringF = new XMLStringForm();
                xmlStringF.XmlString.Text = KeyM.ToXmlString(GetKeyType(comboBox1.SelectedIndex), true);
                xmlStringF.Show();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void LoadKey()
        {
            openFileDialog1.Title = "Select a key to open!";
            openFileDialog1.Filter = "Pem format (*.txt, *.pem)|*.txt;*.pem|Putty key (*.ppk)|*.ppk|All files (*.*)|*.*";
            openFileDialog1.ShowDialog();
        }

        private void PublicKeySave()
        {
            savePublicKey.Title = "Where do you want to save public key?";
            savePublicKey.Filter = "All files (*.*)|*.*";
            savePublicKey.ShowDialog();
        }

        private void PrivateKeySave()
        {
            savePrivatekey.Title = "Where do you want to save private key?";
            savePrivatekey.Filter = "Pem format (*.txt, *.pem)|*.txt;*.pem|Putty key (*.ppk)|*.ppk|All files (*.*)|*.*";
            savePrivatekey.ShowDialog();
        }

        private void generateToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Cursor = Cursors.AppStarting;
            GenerateKey();
            Cursor = Cursors.Default;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            PrivateKeySave();
        }

        private void exportXMLToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ShowXMLForm();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            PublicKeySave();
        }

        private WeOnlyDo.Security.Cryptography.SSHKeyTypes GetKeyType(int KeyValue)
        {
            WeOnlyDo.Security.Cryptography.SSHKeyTypes KeyType = new WeOnlyDo.Security.Cryptography.SSHKeyTypes();
            if (KeyValue == 0)
            {
                KeyType = WeOnlyDo.Security.Cryptography.SSHKeyTypes.RSAKey;
            }
            else if (KeyValue == 1)
            {
                KeyType = WeOnlyDo.Security.Cryptography.SSHKeyTypes.DSAKey;
            }
            return KeyType;
        }

        private void aboutToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            AboutBox1 AboutForm = new AboutBox1();
            AboutForm.ShowDialog();
        }

        private void helpToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Not Implemented yet... Coming soon!");
        }

        private void button5_Click(object sender, EventArgs e)
        {
            ShowXMLForm();
        }

        private void LoadKeyMenuItem_Click(object sender, EventArgs e)
        {
            LoadKey();
        }

        private void SavePublicKeyMenuItem_Click(object sender, EventArgs e)
        {
            PublicKeySave();
        }

        private void SavePKeyMenuItem_Click(object sender, EventArgs e)
        {
            PrivateKeySave();
        }
    }

    
}